require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&ARCHIVE_H_INCLUDED)) {
    eval 'sub ARCHIVE_H_INCLUDED () {1;}' unless defined(&ARCHIVE_H_INCLUDED);
    if(defined(&__BORLANDC__)  && (defined(&__BORLANDC__) ? &__BORLANDC__ : undef) >= 0x560) {
	eval 'sub __LA_STDINT_H () {< ($stdint->{h})>;}' unless defined(&__LA_STDINT_H);
    }
 elsif(!defined(&__WATCOMC__)  && !defined(&_MSC_VER)  && !defined(&__INTERIX)  && !defined(&__BORLANDC__)) {
	eval 'sub __LA_STDINT_H () {< ($inttypes->{h})>;}' unless defined(&__LA_STDINT_H);
    }
    require 'sys/stat.ph';
    require 'sys/types.ph';
    if(defined(&__LA_STDINT_H)) {
    }
    require 'stdio.ph';
    if(defined(&_WIN32)  && !defined(&__CYGWIN__)) {
	eval 'sub __LA_INT64_T () { &__int64;}' unless defined(&__LA_INT64_T);
	if(defined(&_SSIZE_T_DEFINED) || defined(&_SSIZE_T_)) {
	    eval 'sub __LA_SSIZE_T () { &ssize_t;}' unless defined(&__LA_SSIZE_T);
	}
 elsif(defined(&_WIN64)) {
	    eval 'sub __LA_SSIZE_T () { &__int64;}' unless defined(&__LA_SSIZE_T);
	} else {
	    eval 'sub __LA_SSIZE_T () {\'long\';}' unless defined(&__LA_SSIZE_T);
	}
	if(defined(&__BORLANDC__)) {
	    eval 'sub __LA_UID_T () { &uid_t;}' unless defined(&__LA_UID_T);
	    eval 'sub __LA_GID_T () { &gid_t;}' unless defined(&__LA_GID_T);
	} else {
	    eval 'sub __LA_UID_T () {\'short\';}' unless defined(&__LA_UID_T);
	    eval 'sub __LA_GID_T () {\'short\';}' unless defined(&__LA_GID_T);
	}
    } else {
	require 'unistd.ph';
	eval 'sub __LA_INT64_T () { &int64_t;}' unless defined(&__LA_INT64_T);
	eval 'sub __LA_SSIZE_T () { &ssize_t;}' unless defined(&__LA_SSIZE_T);
	eval 'sub __LA_UID_T () { &uid_t;}' unless defined(&__LA_UID_T);
	eval 'sub __LA_GID_T () { &gid_t;}' unless defined(&__LA_GID_T);
    }
    if(((defined (&__WIN32__)) || (defined (&_WIN32)) || defined(&__CYGWIN__))  && (!defined (&LIBARCHIVE_STATIC))) {
	if(defined(&__LIBARCHIVE_BUILD)) {
	    if(defined(&__GNUC__)) {
		eval 'sub __LA_DECL () { &__attribute__(( &dllexport))  &extern;}' unless defined(&__LA_DECL);
	    } else {
		eval 'sub __LA_DECL () { &__declspec( &dllexport);}' unless defined(&__LA_DECL);
	    }
	} else {
	    if(defined(&__GNUC__)) {
		eval 'sub __LA_DECL () { &__attribute__(( &dllimport))  &extern;}' unless defined(&__LA_DECL);
	    } else {
		eval 'sub __LA_DECL () { &__declspec( &dllimport);}' unless defined(&__LA_DECL);
	    }
	}
    } else {
	eval 'sub __LA_DECL () {1;}' unless defined(&__LA_DECL);
    }
    if(defined(&__GNUC__)  && (defined(&__GNUC__) ? &__GNUC__ : undef) >= 3) {
	eval 'sub __LA_PRINTF {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q( &__attribute__(( &__format__ ( &__printf__, $fmtarg, $firstvararg))));
	}' unless defined(&__LA_PRINTF);
    } else {
	eval 'sub __LA_PRINTF {
	    my($fmtarg, $firstvararg) = @_;
    	    eval q();
	}' unless defined(&__LA_PRINTF);
    }
    if(defined(&__cplusplus)) {
    }
    eval 'sub ARCHIVE_VERSION_NUMBER () {2008005;}' unless defined(&ARCHIVE_VERSION_NUMBER);
    eval 'sub ARCHIVE_VERSION_STRING () {"libarchive 2.8.5";}' unless defined(&ARCHIVE_VERSION_STRING);
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
	eval 'sub ARCHIVE_VERSION_STAMP () { &ARCHIVE_VERSION_NUMBER;}' unless defined(&ARCHIVE_VERSION_STAMP);
	eval 'sub ARCHIVE_LIBRARY_VERSION () { &ARCHIVE_VERSION_STRING;}' unless defined(&ARCHIVE_LIBRARY_VERSION);
	eval 'sub ARCHIVE_API_VERSION () {( &ARCHIVE_VERSION_NUMBER / 1000000);}' unless defined(&ARCHIVE_API_VERSION);
	eval 'sub ARCHIVE_API_FEATURE () {(( &ARCHIVE_VERSION_NUMBER / 1000) % 1000);}' unless defined(&ARCHIVE_API_FEATURE);
    }
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
	eval 'sub ARCHIVE_BYTES_PER_RECORD () {512;}' unless defined(&ARCHIVE_BYTES_PER_RECORD);
	eval 'sub ARCHIVE_DEFAULT_BYTES_PER_BLOCK () {10240;}' unless defined(&ARCHIVE_DEFAULT_BYTES_PER_BLOCK);
    }
    eval 'sub ARCHIVE_EOF () {1;}' unless defined(&ARCHIVE_EOF);
    eval 'sub ARCHIVE_OK () {0;}' unless defined(&ARCHIVE_OK);
    eval 'sub ARCHIVE_RETRY () {(-10);}' unless defined(&ARCHIVE_RETRY);
    eval 'sub ARCHIVE_WARN () {(-20);}' unless defined(&ARCHIVE_WARN);
    eval 'sub ARCHIVE_FAILED () {(-25);}' unless defined(&ARCHIVE_FAILED);
    eval 'sub ARCHIVE_FATAL () {(-30);}' unless defined(&ARCHIVE_FATAL);
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 2000000) {
    }
 elsif((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
    } else {
    }
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
    }
    eval 'sub ARCHIVE_COMPRESSION_NONE () {0;}' unless defined(&ARCHIVE_COMPRESSION_NONE);
    eval 'sub ARCHIVE_COMPRESSION_GZIP () {1;}' unless defined(&ARCHIVE_COMPRESSION_GZIP);
    eval 'sub ARCHIVE_COMPRESSION_BZIP2 () {2;}' unless defined(&ARCHIVE_COMPRESSION_BZIP2);
    eval 'sub ARCHIVE_COMPRESSION_COMPRESS () {3;}' unless defined(&ARCHIVE_COMPRESSION_COMPRESS);
    eval 'sub ARCHIVE_COMPRESSION_PROGRAM () {4;}' unless defined(&ARCHIVE_COMPRESSION_PROGRAM);
    eval 'sub ARCHIVE_COMPRESSION_LZMA () {5;}' unless defined(&ARCHIVE_COMPRESSION_LZMA);
    eval 'sub ARCHIVE_COMPRESSION_XZ () {6;}' unless defined(&ARCHIVE_COMPRESSION_XZ);
    eval 'sub ARCHIVE_COMPRESSION_UU () {7;}' unless defined(&ARCHIVE_COMPRESSION_UU);
    eval 'sub ARCHIVE_COMPRESSION_RPM () {8;}' unless defined(&ARCHIVE_COMPRESSION_RPM);
    eval 'sub ARCHIVE_FORMAT_BASE_MASK () {0xff0000;}' unless defined(&ARCHIVE_FORMAT_BASE_MASK);
    eval 'sub ARCHIVE_FORMAT_CPIO () {0x10000;}' unless defined(&ARCHIVE_FORMAT_CPIO);
    eval 'sub ARCHIVE_FORMAT_CPIO_POSIX () {( &ARCHIVE_FORMAT_CPIO | 1);}' unless defined(&ARCHIVE_FORMAT_CPIO_POSIX);
    eval 'sub ARCHIVE_FORMAT_CPIO_BIN_LE () {( &ARCHIVE_FORMAT_CPIO | 2);}' unless defined(&ARCHIVE_FORMAT_CPIO_BIN_LE);
    eval 'sub ARCHIVE_FORMAT_CPIO_BIN_BE () {( &ARCHIVE_FORMAT_CPIO | 3);}' unless defined(&ARCHIVE_FORMAT_CPIO_BIN_BE);
    eval 'sub ARCHIVE_FORMAT_CPIO_SVR4_NOCRC () {( &ARCHIVE_FORMAT_CPIO | 4);}' unless defined(&ARCHIVE_FORMAT_CPIO_SVR4_NOCRC);
    eval 'sub ARCHIVE_FORMAT_CPIO_SVR4_CRC () {( &ARCHIVE_FORMAT_CPIO | 5);}' unless defined(&ARCHIVE_FORMAT_CPIO_SVR4_CRC);
    eval 'sub ARCHIVE_FORMAT_SHAR () {0x20000;}' unless defined(&ARCHIVE_FORMAT_SHAR);
    eval 'sub ARCHIVE_FORMAT_SHAR_BASE () {( &ARCHIVE_FORMAT_SHAR | 1);}' unless defined(&ARCHIVE_FORMAT_SHAR_BASE);
    eval 'sub ARCHIVE_FORMAT_SHAR_DUMP () {( &ARCHIVE_FORMAT_SHAR | 2);}' unless defined(&ARCHIVE_FORMAT_SHAR_DUMP);
    eval 'sub ARCHIVE_FORMAT_TAR () {0x30000;}' unless defined(&ARCHIVE_FORMAT_TAR);
    eval 'sub ARCHIVE_FORMAT_TAR_USTAR () {( &ARCHIVE_FORMAT_TAR | 1);}' unless defined(&ARCHIVE_FORMAT_TAR_USTAR);
    eval 'sub ARCHIVE_FORMAT_TAR_PAX_INTERCHANGE () {( &ARCHIVE_FORMAT_TAR | 2);}' unless defined(&ARCHIVE_FORMAT_TAR_PAX_INTERCHANGE);
    eval 'sub ARCHIVE_FORMAT_TAR_PAX_RESTRICTED () {( &ARCHIVE_FORMAT_TAR | 3);}' unless defined(&ARCHIVE_FORMAT_TAR_PAX_RESTRICTED);
    eval 'sub ARCHIVE_FORMAT_TAR_GNUTAR () {( &ARCHIVE_FORMAT_TAR | 4);}' unless defined(&ARCHIVE_FORMAT_TAR_GNUTAR);
    eval 'sub ARCHIVE_FORMAT_ISO9660 () {0x40000;}' unless defined(&ARCHIVE_FORMAT_ISO9660);
    eval 'sub ARCHIVE_FORMAT_ISO9660_ROCKRIDGE () {( &ARCHIVE_FORMAT_ISO9660 | 1);}' unless defined(&ARCHIVE_FORMAT_ISO9660_ROCKRIDGE);
    eval 'sub ARCHIVE_FORMAT_ZIP () {0x50000;}' unless defined(&ARCHIVE_FORMAT_ZIP);
    eval 'sub ARCHIVE_FORMAT_EMPTY () {0x60000;}' unless defined(&ARCHIVE_FORMAT_EMPTY);
    eval 'sub ARCHIVE_FORMAT_AR () {0x70000;}' unless defined(&ARCHIVE_FORMAT_AR);
    eval 'sub ARCHIVE_FORMAT_AR_GNU () {( &ARCHIVE_FORMAT_AR | 1);}' unless defined(&ARCHIVE_FORMAT_AR_GNU);
    eval 'sub ARCHIVE_FORMAT_AR_BSD () {( &ARCHIVE_FORMAT_AR | 2);}' unless defined(&ARCHIVE_FORMAT_AR_BSD);
    eval 'sub ARCHIVE_FORMAT_MTREE () {0x80000;}' unless defined(&ARCHIVE_FORMAT_MTREE);
    eval 'sub ARCHIVE_FORMAT_RAW () {0x90000;}' unless defined(&ARCHIVE_FORMAT_RAW);
    eval 'sub ARCHIVE_FORMAT_XAR () {0xa0000;}' unless defined(&ARCHIVE_FORMAT_XAR);
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
    } else {
    }
    eval 'sub ARCHIVE_EXTRACT_OWNER () {(0x1);}' unless defined(&ARCHIVE_EXTRACT_OWNER);
    eval 'sub ARCHIVE_EXTRACT_PERM () {(0x2);}' unless defined(&ARCHIVE_EXTRACT_PERM);
    eval 'sub ARCHIVE_EXTRACT_TIME () {(0x4);}' unless defined(&ARCHIVE_EXTRACT_TIME);
    eval 'sub ARCHIVE_EXTRACT_NO_OVERWRITE () {(0x8);}' unless defined(&ARCHIVE_EXTRACT_NO_OVERWRITE);
    eval 'sub ARCHIVE_EXTRACT_UNLINK () {(0x10);}' unless defined(&ARCHIVE_EXTRACT_UNLINK);
    eval 'sub ARCHIVE_EXTRACT_ACL () {(0x20);}' unless defined(&ARCHIVE_EXTRACT_ACL);
    eval 'sub ARCHIVE_EXTRACT_FFLAGS () {(0x40);}' unless defined(&ARCHIVE_EXTRACT_FFLAGS);
    eval 'sub ARCHIVE_EXTRACT_XATTR () {(0x80);}' unless defined(&ARCHIVE_EXTRACT_XATTR);
    eval 'sub ARCHIVE_EXTRACT_SECURE_SYMLINKS () {(0x100);}' unless defined(&ARCHIVE_EXTRACT_SECURE_SYMLINKS);
    eval 'sub ARCHIVE_EXTRACT_SECURE_NODOTDOT () {(0x200);}' unless defined(&ARCHIVE_EXTRACT_SECURE_NODOTDOT);
    eval 'sub ARCHIVE_EXTRACT_NO_AUTODIR () {(0x400);}' unless defined(&ARCHIVE_EXTRACT_NO_AUTODIR);
    eval 'sub ARCHIVE_EXTRACT_NO_OVERWRITE_NEWER () {(0x800);}' unless defined(&ARCHIVE_EXTRACT_NO_OVERWRITE_NEWER);
    eval 'sub ARCHIVE_EXTRACT_SPARSE () {(0x1000);}' unless defined(&ARCHIVE_EXTRACT_SPARSE);
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 4000000) {
    }
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 2000000) {
    } else {
    }
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 3000000) {
    } else {
    }
    if((defined(&ARCHIVE_VERSION_NUMBER) ? &ARCHIVE_VERSION_NUMBER : undef) < 4000000) {
    }
    if(defined(&__cplusplus)) {
    }
    undef(&__LA_DECL) if defined(&__LA_DECL);
    undef(&__LA_GID_T) if defined(&__LA_GID_T);
    undef(&__LA_UID_T) if defined(&__LA_UID_T);
}
1;
