require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_REG_H_)) {
    eval 'sub _MACHINE_REG_H_ () {1;}' unless defined(&_MACHINE_REG_H_);
    if(defined(&_KERNEL)  && !defined(&_STANDALONE)) {
	require 'machine/opt_compat.ph';
    }
    eval 'sub DBREG_DR7_LOCAL_ENABLE () {0x1;}' unless defined(&DBREG_DR7_LOCAL_ENABLE);
    eval 'sub DBREG_DR7_GLOBAL_ENABLE () {0x2;}' unless defined(&DBREG_DR7_GLOBAL_ENABLE);
    eval 'sub DBREG_DR7_LEN_1 () {0x;}' unless defined(&DBREG_DR7_LEN_1);
    eval 'sub DBREG_DR7_LEN_2 () {0x1;}' unless defined(&DBREG_DR7_LEN_2);
    eval 'sub DBREG_DR7_LEN_4 () {0x3;}' unless defined(&DBREG_DR7_LEN_4);
    eval 'sub DBREG_DR7_LEN_8 () {0x2;}' unless defined(&DBREG_DR7_LEN_8);
    eval 'sub DBREG_DR7_EXEC () {0x;}' unless defined(&DBREG_DR7_EXEC);
    eval 'sub DBREG_DR7_WRONLY () {0x1;}' unless defined(&DBREG_DR7_WRONLY);
    eval 'sub DBREG_DR7_RDWR () {0x3;}' unless defined(&DBREG_DR7_RDWR);
    eval 'sub DBREG_DR7_MASK {
        my($i) = @_;
	    eval q((0xf << (($i) * 4+ 16) | 0x3 << ($i) * 2));
    }' unless defined(&DBREG_DR7_MASK);
    eval 'sub DBREG_DR7_SET {
        my($i, $len, $access, $enable) = @_;
	    eval q(((($len) << 2| ($access)) << (($i) * 4+ 16) | ($enable) << ($i) * 2));
    }' unless defined(&DBREG_DR7_SET);
    eval 'sub DBREG_DR7_GD () {0x2000;}' unless defined(&DBREG_DR7_GD);
    eval 'sub DBREG_DR7_ENABLED {
        my($d, $i) = @_;
	    eval q(((($d) & 0x3 << ($i) * 2) != 0));
    }' unless defined(&DBREG_DR7_ENABLED);
    eval 'sub DBREG_DR7_ACCESS {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 16) & 0x3));
    }' unless defined(&DBREG_DR7_ACCESS);
    eval 'sub DBREG_DR7_LEN {
        my($d, $i) = @_;
	    eval q((($d) >> (($i) * 4+ 18) & 0x3));
    }' unless defined(&DBREG_DR7_LEN);
    eval 'sub DBREG_DRX {
        my($d,$x) = @_;
	    eval q((($d)-> $dr[($x)]));
    }' unless defined(&DBREG_DRX);
    if(defined(&COMPAT_FREEBSD32)) {
	require 'machine/fpu.ph';
	require 'compat/ia32/ia32_reg.ph';
    }
    if(defined(&_KERNEL)) {
    }
}
1;
