require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CALLOUT_H_)) {
    eval 'sub _SYS_CALLOUT_H_ () {1;}' unless defined(&_SYS_CALLOUT_H_);
    require 'sys/queue.ph';
    eval 'sub CALLOUT_LOCAL_ALLOC () {0x1;}' unless defined(&CALLOUT_LOCAL_ALLOC);
    eval 'sub CALLOUT_ACTIVE () {0x2;}' unless defined(&CALLOUT_ACTIVE);
    eval 'sub CALLOUT_PENDING () {0x4;}' unless defined(&CALLOUT_PENDING);
    eval 'sub CALLOUT_MPSAFE () {0x8;}' unless defined(&CALLOUT_MPSAFE);
    eval 'sub CALLOUT_RETURNUNLOCKED () {0x10;}' unless defined(&CALLOUT_RETURNUNLOCKED);
    eval 'sub CALLOUT_SHAREDLOCK () {0x20;}' unless defined(&CALLOUT_SHAREDLOCK);
    eval 'sub CALLOUT_DFRMIGRATION () {0x40;}' unless defined(&CALLOUT_DFRMIGRATION);
    if(defined(&_KERNEL)) {
	eval 'sub callout_active {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &  &CALLOUT_ACTIVE));
	}' unless defined(&callout_active);
	eval 'sub callout_deactivate {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &= ~ &CALLOUT_ACTIVE));
	}' unless defined(&callout_deactivate);
	eval 'sub callout_drain {
	    my($c) = @_;
    	    eval q( &_callout_stop_safe($c, 1));
	}' unless defined(&callout_drain);
	eval 'sub callout_init_mtx {
	    my($c, $mtx, $flags) = @_;
    	    eval q( &_callout_init_lock(($c), (($mtx) !=  &NULL) ? ($mtx)-> &lock_object :  &NULL, ($flags)));
	}' unless defined(&callout_init_mtx);
	eval 'sub callout_init_rw {
	    my($c, $rw, $flags) = @_;
    	    eval q( &_callout_init_lock(($c), (($rw) !=  &NULL) ? ($rw)-> &lock_object :  &NULL, ($flags)));
	}' unless defined(&callout_init_rw);
	eval 'sub callout_pending {
	    my($c) = @_;
    	    eval q((($c)-> &c_flags &  &CALLOUT_PENDING));
	}' unless defined(&callout_pending);
	eval 'sub callout_reset {
	    my($c, $on_tick, $fn, $arg) = @_;
    	    eval q( &callout_reset_on(($c), ($on_tick), ($fn), ($arg), ($c)-> &c_cpu));
	}' unless defined(&callout_reset);
	eval 'sub callout_reset_curcpu {
	    my($c, $on_tick, $fn, $arg) = @_;
    	    eval q( &callout_reset_on(($c), ($on_tick), ($fn), ($arg),  &PCPU_GET( &cpuid)));
	}' unless defined(&callout_reset_curcpu);
	eval 'sub callout_schedule_curcpu {
	    my($c, $on_tick) = @_;
    	    eval q( &callout_schedule_on(($c), ($on_tick),  &PCPU_GET( &cpuid)));
	}' unless defined(&callout_schedule_curcpu);
	eval 'sub callout_stop {
	    my($c) = @_;
    	    eval q( &_callout_stop_safe($c, 0));
	}' unless defined(&callout_stop);
    }
}
1;
