require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CONS_H_)) {
    eval 'sub _MACHINE_CONS_H_ () {1;}' unless defined(&_MACHINE_CONS_H_);
    eval 'sub CN_DEAD () {0;}' unless defined(&CN_DEAD);
    eval 'sub CN_LOW () {1;}' unless defined(&CN_LOW);
    eval 'sub CN_NORMAL () {2;}' unless defined(&CN_NORMAL);
    eval 'sub CN_INTERNAL () {3;}' unless defined(&CN_INTERNAL);
    eval 'sub CN_REMOTE () {4;}' unless defined(&CN_REMOTE);
    eval 'sub CN_FLAG_NODEBUG () {0x1;}' unless defined(&CN_FLAG_NODEBUG);
    eval 'sub CN_FLAG_NOAVAIL () {0x2;}' unless defined(&CN_FLAG_NOAVAIL);
    if(defined(&_KERNEL)) {
	eval 'sub CONS_DRIVER {
	    my($name, $probe, $init, $term, $getc, $checkc, $putc, $dbctl) = @_;
    	    eval q( &static \'struct consdev\' $name &_consdev = { $probe, $init, $term, $getc, $checkc, $putc };  &DATA_SET( &cons_set, $name &_consdev));
	}' unless defined(&CONS_DRIVER);
	eval 'sub CONSOLE_DRIVER {
	    my($name) = @_;
    	    eval q( &static \'struct consdev\' $name &_consdev = { . &cn_probe = $name &_cnprobe, . &cn_init = $name &_cninit, . &cn_term = $name &_cnterm, . &cn_getc = $name &_cngetc, . &cn_putc = $name &_cnputc, };  &DATA_SET( &cons_set, $name &_consdev));
	}' unless defined(&CONSOLE_DRIVER);
    }
}
1;
