require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_WATCHDOG_H)) {
    eval 'sub _SYS_WATCHDOG_H () {1;}' unless defined(&_SYS_WATCHDOG_H);
    require 'sys/ioccom.ph';
    eval 'sub _PATH_WATCHDOG () {"fido";}' unless defined(&_PATH_WATCHDOG);
    eval 'sub WDIOCPATPAT () { &_IOW(ord(\'W\'), 42, \'u_int\');}' unless defined(&WDIOCPATPAT);
    eval 'sub WD_ACTIVE () {0x8000000;}' unless defined(&WD_ACTIVE);
    eval 'sub WD_PASSIVE () {0x400000;}' unless defined(&WD_PASSIVE);
    eval 'sub WD_LASTVAL () {0x200000;}' unless defined(&WD_LASTVAL);
    eval 'sub WD_INTERVAL () {0xff;}' unless defined(&WD_INTERVAL);
    eval 'sub WD_TO_NEVER () {0;}' unless defined(&WD_TO_NEVER);
    eval 'sub WD_TO_1MS () {20;}' unless defined(&WD_TO_1MS);
    eval 'sub WD_TO_125MS () {27;}' unless defined(&WD_TO_125MS);
    eval 'sub WD_TO_250MS () {28;}' unless defined(&WD_TO_250MS);
    eval 'sub WD_TO_500MS () {29;}' unless defined(&WD_TO_500MS);
    eval 'sub WD_TO_1SEC () {30;}' unless defined(&WD_TO_1SEC);
    eval 'sub WD_TO_2SEC () {31;}' unless defined(&WD_TO_2SEC);
    eval 'sub WD_TO_4SEC () {32;}' unless defined(&WD_TO_4SEC);
    eval 'sub WD_TO_8SEC () {33;}' unless defined(&WD_TO_8SEC);
    eval 'sub WD_TO_16SEC () {34;}' unless defined(&WD_TO_16SEC);
    eval 'sub WD_TO_32SEC () {35;}' unless defined(&WD_TO_32SEC);
    if(defined(&_KERNEL)) {
	require 'sys/eventhandler.ph';
    }
}
1;
