require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ELF_H_)) {
    eval 'sub _MACHINE_ELF_H_ () {1;}' unless defined(&_MACHINE_ELF_H_);
    unless(defined(&__ELF_WORD_SIZE)) {
	eval 'sub __ELF_WORD_SIZE () {64;}' unless defined(&__ELF_WORD_SIZE);
    }
    require 'sys/elf32.ph';
    require 'sys/elf64.ph';
    require 'sys/elf_generic.ph';
    eval 'sub ELF_ARCH () { &EM_X86_64;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_ARCH32 () { &EM_386;}' unless defined(&ELF_ARCH32);
    eval 'sub ELF_MACHINE_OK {
        my($x) = @_;
	    eval q((($x) ==  &EM_X86_64));
    }' unless defined(&ELF_MACHINE_OK);
    eval 'sub AT_NULL () {0;}' unless defined(&AT_NULL);
    eval 'sub AT_IGNORE () {1;}' unless defined(&AT_IGNORE);
    eval 'sub AT_EXECFD () {2;}' unless defined(&AT_EXECFD);
    eval 'sub AT_PHDR () {3;}' unless defined(&AT_PHDR);
    eval 'sub AT_PHENT () {4;}' unless defined(&AT_PHENT);
    eval 'sub AT_PHNUM () {5;}' unless defined(&AT_PHNUM);
    eval 'sub AT_PAGESZ () {6;}' unless defined(&AT_PAGESZ);
    eval 'sub AT_BASE () {7;}' unless defined(&AT_BASE);
    eval 'sub AT_FLAGS () {8;}' unless defined(&AT_FLAGS);
    eval 'sub AT_ENTRY () {9;}' unless defined(&AT_ENTRY);
    eval 'sub AT_NOTELF () {10;}' unless defined(&AT_NOTELF);
    eval 'sub AT_UID () {11;}' unless defined(&AT_UID);
    eval 'sub AT_EUID () {12;}' unless defined(&AT_EUID);
    eval 'sub AT_GID () {13;}' unless defined(&AT_GID);
    eval 'sub AT_EGID () {14;}' unless defined(&AT_EGID);
    eval 'sub AT_EXECPATH () {15;}' unless defined(&AT_EXECPATH);
    eval 'sub AT_COUNT () {16;}' unless defined(&AT_COUNT);
    eval 'sub R_X86_64_COUNT () {24;}' unless defined(&R_X86_64_COUNT);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 32) {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS32;}' unless defined(&ELF_TARG_CLASS);
    } else {
	eval 'sub ELF_TARG_CLASS () { &ELFCLASS64;}' unless defined(&ELF_TARG_CLASS);
    }
    eval 'sub ELF_TARG_DATA () { &ELFDATA2LSB;}' unless defined(&ELF_TARG_DATA);
    eval 'sub ELF_TARG_MACH () { &EM_X86_64;}' unless defined(&ELF_TARG_MACH);
    eval 'sub ELF_TARG_VER () {1;}' unless defined(&ELF_TARG_VER);
    if((defined(&__ELF_WORD_SIZE) ? &__ELF_WORD_SIZE : undef) == 32) {
	eval 'sub ET_DYN_LOAD_ADDR () {0x1001000;}' unless defined(&ET_DYN_LOAD_ADDR);
    } else {
	eval 'sub ET_DYN_LOAD_ADDR () {0x1021000;}' unless defined(&ET_DYN_LOAD_ADDR);
    }
}
1;
