require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_SEGMENTS_H_)) {
    eval 'sub _MACHINE_SEGMENTS_H_ () {1;}' unless defined(&_MACHINE_SEGMENTS_H_);
    eval 'sub SEL_RPL_MASK () {3;}' unless defined(&SEL_RPL_MASK);
    eval 'sub ISPL {
        my($s) = @_;
	    eval q((($s)&3));
    }' unless defined(&ISPL);
    eval 'sub SEL_KPL () {0;}' unless defined(&SEL_KPL);
    eval 'sub SEL_UPL () {3;}' unless defined(&SEL_UPL);
    eval 'sub ISLDT {
        my($s) = @_;
	    eval q((($s) &SEL_LDT));
    }' unless defined(&ISLDT);
    eval 'sub SEL_LDT () {4;}' unless defined(&SEL_LDT);
    eval 'sub IDXSEL {
        my($s) = @_;
	    eval q(((($s)>>3) & 0x1fff));
    }' unless defined(&IDXSEL);
    eval 'sub LSEL {
        my($s,$r) = @_;
	    eval q(((($s)<<3) |  &SEL_LDT | $r));
    }' unless defined(&LSEL);
    eval 'sub GSEL {
        my($s,$r) = @_;
	    eval q(((($s)<<3) | $r));
    }' unless defined(&GSEL);
    eval 'sub USD_GETBASE {
        my($sd) = @_;
	    eval q(((($sd)-> &sd_lobase) | ($sd)-> &sd_hibase << 24));
    }' unless defined(&USD_GETBASE);
    eval 'sub USD_SETBASE {
        my($sd, $b) = @_;
	    eval q(($sd)-> &sd_lobase = ($b); ($sd)-> &sd_hibase = (($b) >> 24););
    }' unless defined(&USD_SETBASE);
    eval 'sub USD_GETLIMIT {
        my($sd) = @_;
	    eval q(((($sd)-> &sd_lolimit) | ($sd)-> &sd_hilimit << 16));
    }' unless defined(&USD_GETLIMIT);
    eval 'sub USD_SETLIMIT {
        my($sd, $l) = @_;
	    eval q(($sd)-> &sd_lolimit = ($l); ($sd)-> &sd_hilimit = (($l) >> 16););
    }' unless defined(&USD_SETLIMIT);
    eval 'sub SDT_SYSNULL () {0;}' unless defined(&SDT_SYSNULL);
    eval 'sub SDT_SYS286TSS () {1;}' unless defined(&SDT_SYS286TSS);
    eval 'sub SDT_SYSLDT () {2;}' unless defined(&SDT_SYSLDT);
    eval 'sub SDT_SYS286BSY () {3;}' unless defined(&SDT_SYS286BSY);
    eval 'sub SDT_SYS286CGT () {4;}' unless defined(&SDT_SYS286CGT);
    eval 'sub SDT_SYSTASKGT () {5;}' unless defined(&SDT_SYSTASKGT);
    eval 'sub SDT_SYS286IGT () {6;}' unless defined(&SDT_SYS286IGT);
    eval 'sub SDT_SYS286TGT () {7;}' unless defined(&SDT_SYS286TGT);
    eval 'sub SDT_SYSNULL2 () {8;}' unless defined(&SDT_SYSNULL2);
    eval 'sub SDT_SYSTSS () {9;}' unless defined(&SDT_SYSTSS);
    eval 'sub SDT_SYSNULL3 () {10;}' unless defined(&SDT_SYSNULL3);
    eval 'sub SDT_SYSBSY () {11;}' unless defined(&SDT_SYSBSY);
    eval 'sub SDT_SYSCGT () {12;}' unless defined(&SDT_SYSCGT);
    eval 'sub SDT_SYSNULL4 () {13;}' unless defined(&SDT_SYSNULL4);
    eval 'sub SDT_SYSIGT () {14;}' unless defined(&SDT_SYSIGT);
    eval 'sub SDT_SYSTGT () {15;}' unless defined(&SDT_SYSTGT);
    eval 'sub SDT_MEMRO () {16;}' unless defined(&SDT_MEMRO);
    eval 'sub SDT_MEMROA () {17;}' unless defined(&SDT_MEMROA);
    eval 'sub SDT_MEMRW () {18;}' unless defined(&SDT_MEMRW);
    eval 'sub SDT_MEMRWA () {19;}' unless defined(&SDT_MEMRWA);
    eval 'sub SDT_MEMROD () {20;}' unless defined(&SDT_MEMROD);
    eval 'sub SDT_MEMRODA () {21;}' unless defined(&SDT_MEMRODA);
    eval 'sub SDT_MEMRWD () {22;}' unless defined(&SDT_MEMRWD);
    eval 'sub SDT_MEMRWDA () {23;}' unless defined(&SDT_MEMRWDA);
    eval 'sub SDT_MEME () {24;}' unless defined(&SDT_MEME);
    eval 'sub SDT_MEMEA () {25;}' unless defined(&SDT_MEMEA);
    eval 'sub SDT_MEMER () {26;}' unless defined(&SDT_MEMER);
    eval 'sub SDT_MEMERA () {27;}' unless defined(&SDT_MEMERA);
    eval 'sub SDT_MEMEC () {28;}' unless defined(&SDT_MEMEC);
    eval 'sub SDT_MEMEAC () {29;}' unless defined(&SDT_MEMEAC);
    eval 'sub SDT_MEMERC () {30;}' unless defined(&SDT_MEMERC);
    eval 'sub SDT_MEMERAC () {31;}' unless defined(&SDT_MEMERAC);
    eval 'sub NIDT () {256;}' unless defined(&NIDT);
    eval 'sub NRSVIDT () {32;}' unless defined(&NRSVIDT);
    eval 'sub IDT_DE () {0;}' unless defined(&IDT_DE);
    eval 'sub IDT_DB () {1;}' unless defined(&IDT_DB);
    eval 'sub IDT_NMI () {2;}' unless defined(&IDT_NMI);
    eval 'sub IDT_BP () {3;}' unless defined(&IDT_BP);
    eval 'sub IDT_OF () {4;}' unless defined(&IDT_OF);
    eval 'sub IDT_BR () {5;}' unless defined(&IDT_BR);
    eval 'sub IDT_UD () {6;}' unless defined(&IDT_UD);
    eval 'sub IDT_NM () {7;}' unless defined(&IDT_NM);
    eval 'sub IDT_DF () {8;}' unless defined(&IDT_DF);
    eval 'sub IDT_FPUGP () {9;}' unless defined(&IDT_FPUGP);
    eval 'sub IDT_TS () {10;}' unless defined(&IDT_TS);
    eval 'sub IDT_NP () {11;}' unless defined(&IDT_NP);
    eval 'sub IDT_SS () {12;}' unless defined(&IDT_SS);
    eval 'sub IDT_GP () {13;}' unless defined(&IDT_GP);
    eval 'sub IDT_PF () {14;}' unless defined(&IDT_PF);
    eval 'sub IDT_MF () {16;}' unless defined(&IDT_MF);
    eval 'sub IDT_AC () {17;}' unless defined(&IDT_AC);
    eval 'sub IDT_MC () {18;}' unless defined(&IDT_MC);
    eval 'sub IDT_XF () {19;}' unless defined(&IDT_XF);
    eval 'sub IDT_IO_INTS () { &NRSVIDT;}' unless defined(&IDT_IO_INTS);
    eval 'sub IDT_SYSCALL () {0x80;}' unless defined(&IDT_SYSCALL);
    eval 'sub IDT_DTRACE_RET () {0x92;}' unless defined(&IDT_DTRACE_RET);
    eval 'sub GNULL_SEL () {0;}' unless defined(&GNULL_SEL);
    eval 'sub GNULL2_SEL () {1;}' unless defined(&GNULL2_SEL);
    eval 'sub GUFS32_SEL () {2;}' unless defined(&GUFS32_SEL);
    eval 'sub GUGS32_SEL () {3;}' unless defined(&GUGS32_SEL);
    eval 'sub GCODE_SEL () {4;}' unless defined(&GCODE_SEL);
    eval 'sub GDATA_SEL () {5;}' unless defined(&GDATA_SEL);
    eval 'sub GUCODE32_SEL () {6;}' unless defined(&GUCODE32_SEL);
    eval 'sub GUDATA_SEL () {7;}' unless defined(&GUDATA_SEL);
    eval 'sub GUCODE_SEL () {8;}' unless defined(&GUCODE_SEL);
    eval 'sub GPROC0_SEL () {9;}' unless defined(&GPROC0_SEL);
    eval 'sub GUSERLDT_SEL () {11;}' unless defined(&GUSERLDT_SEL);
    eval 'sub NGDT () {13;}' unless defined(&NGDT);
    if(defined(&_KERNEL)) {
    }
}
1;
