require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_PMCKERN_H_)) {
    eval 'sub _SYS_PMCKERN_H_ () {1;}' unless defined(&_SYS_PMCKERN_H_);
    require 'sys/param.ph';
    require 'sys/kernel.ph';
    require 'sys/lock.ph';
    require 'sys/proc.ph';
    require 'sys/sx.ph';
    eval 'sub PMC_FN_PROCESS_EXEC () {1;}' unless defined(&PMC_FN_PROCESS_EXEC);
    eval 'sub PMC_FN_CSW_IN () {2;}' unless defined(&PMC_FN_CSW_IN);
    eval 'sub PMC_FN_CSW_OUT () {3;}' unless defined(&PMC_FN_CSW_OUT);
    eval 'sub PMC_FN_DO_SAMPLES () {4;}' unless defined(&PMC_FN_DO_SAMPLES);
    eval 'sub PMC_FN_KLD_LOAD () {5;}' unless defined(&PMC_FN_KLD_LOAD);
    eval 'sub PMC_FN_KLD_UNLOAD () {6;}' unless defined(&PMC_FN_KLD_UNLOAD);
    eval 'sub PMC_FN_MMAP () {7;}' unless defined(&PMC_FN_MMAP);
    eval 'sub PMC_FN_MUNMAP () {8;}' unless defined(&PMC_FN_MUNMAP);
    eval 'sub PMC_FN_USER_CALLCHAIN () {9;}' unless defined(&PMC_FN_USER_CALLCHAIN);
    eval 'sub PMC_CALL_HOOK {
        my($t, $cmd, $arg) = @_;
	    eval q( &do {  &sx_slock( &pmc_sx);  &if ( &pmc_hook !=  &NULL) ( &pmc_hook)(($t), ($cmd), ($arg));  &sx_sunlock( &pmc_sx); }  &while (0));
    }' unless defined(&PMC_CALL_HOOK);
    eval 'sub PMC_CALL_HOOK_X {
        my($t, $cmd, $arg) = @_;
	    eval q( &do {  &sx_xlock( &pmc_sx);  &if ( &pmc_hook !=  &NULL) ( &pmc_hook)(($t), ($cmd), ($arg));  &sx_xunlock( &pmc_sx); }  &while (0));
    }' unless defined(&PMC_CALL_HOOK_X);
    eval 'sub PMC_CALL_HOOK_UNLOCKED {
        my($t, $cmd, $arg) = @_;
	    eval q( &do {  &if ( &pmc_hook !=  &NULL) ( &pmc_hook)(($t), ($cmd), ($arg)); }  &while (0));
    }' unless defined(&PMC_CALL_HOOK_UNLOCKED);
    eval 'sub PMC_SWITCH_CONTEXT {
        my($t,$cmd) = @_;
	    eval q( &PMC_CALL_HOOK_UNLOCKED($t,$cmd, &NULL));
    }' unless defined(&PMC_SWITCH_CONTEXT);
    eval 'sub PMC_PROC_IS_USING_PMCS {
        my($p) = @_;
	    eval q(( &__predict_false( &atomic_load_acq_int(($p)-> &p_flag) &  &P_HWPMC)));
    }' unless defined(&PMC_PROC_IS_USING_PMCS);
    eval 'sub PMC_SYSTEM_SAMPLING_ACTIVE () {
        eval q(( &pmc_ss_count > 0));
    }' unless defined(&PMC_SYSTEM_SAMPLING_ACTIVE);
    eval 'sub PMC_CPU_HAS_SAMPLES {
        my($C) = @_;
	    eval q(( &__predict_false( &pmc_cpumask & (1<< ($C)))));
    }' unless defined(&PMC_CPU_HAS_SAMPLES);
    if(defined(&INVARIANTS)) {
    }
}
1;
